﻿/**

*/
module nemuxi.system.log;

debug import std.stdio: wl = writefln, pl = printf;
debug(log) void main() {}

import std.file;
import std.string;
import std.conv;
import std.stream;

import nemuxi.file.file;
import nemuxi.system.timer;
import nemuxi.system.text;
import nemuxi.utility.simple.sysinfo;
import nemuxi.system.staticdata;

/**
Bugs:
	迷走中。
	気にしないでください。

History:
	[V]:
		半ば死んでたログ機能を活性化。
		これに伴い各moduleにて変更部分あり。
		今後ログ機能に関するHistory:の記述は基本的にしない方針。
*/
static struct Logger {
	invariant() {
		if(Flag) assert(fs);
		else     assert(!fs);
	}
	static bool Flag;
	
	static private {
		//string path;
		//invariant string DIR = `.\Logs\`;
		BufferedFile fs;
	}

	/+
	static this() {
		auto date=new DateTime();

		path = format(
			"%s%04s-%02s-%02s(%s)%02s-%02s-%02s.log",
			DIR,
			date.year,
			date.month,
			date.day,
			date.weekName(date.week),
			date.hour,
			date.minute,
			date.second
		);
	}
	+/
	
	static bool flag() {
		return Flag;
	}
	/**
	History:
		[V]:
			nemuxi.system.log.writeの引数変更に伴う修正。
	
		1.00β11:
			ログ開始時にシステム情報の書き出し。
	*/
	static void flag(in bool Flag) {
		
		if(Flag) {
			this.Flag = Flag;
			
			auto date=new DateTime();
			date.format = "[YYYY]-[M]-[DD]([W]) [hh]-[mm]-[ss].log";
			const path = StaticData.logFolder ~ date.toString();
			//if(!exists(DIR)) mkdir(DIR);
			if(!FILE.isExistence(StaticData.logFolder)) {
				FILE.makeFolder(StaticData.logFolder);
			}
			
			fs = new BufferedFile(path.toString(), FileMode.OutNew);
			Logger.write("Log Start.%s%s", newline[],toStringInfo);
		} else {
			if(fs) {
				Logger.write("Log End.");
				fs.close();
			}
			this.Flag = Flag;
			delete fs;
		}
	}
	/+
	static void write(T)(lazy T msg, string file=__FILE__, int line=__LINE__) {
		if(!Flag) {
			return;
		} else {
			assert(fs);
		}
		auto date=new DateTime();
		date.format = "[YYYY]/[M]/[D] [h]:[m]:[s].[ms]";

		auto msgs=splitlines(to!(string)(msg));
		
		auto s=format(
			"<%s> %s(%s)%s%s%s",
			date,
			file,
			line,
			repeat("=", 20),
			newline,
			msgs.join(newline)
		);
		//append(path, s);
		fs.writeLine(s ~ newline);
		fs.flush;
	}
	+/
	/**
	History:
		[V]:
			引数を変更。
	*/
	static void write(string file=__FILE__, int line=__LINE__, T...)(lazy T msgs) {
		if(!Flag) {
			return;
		} else {
			assert(fs);
		}

		auto date=new DateTime();
		date.format = "[YYYY]/[M]/[D] [h]:[m]:[s].[ms]";
		
		string data;
		static if(msgs.length == 1) {
			data = to!(string)(msgs);
		} else {
			static if(
				is(T[0] == string)  ||
				is(T[0] == wstring) ||
				is(T[0] == dstring) ||
				is(T[0] == Text)
			) {
				string f;
				static if(is(T[0] == string)) {
					f = msgs[0];
				} else static if(is(T[0] == Text)) {
					f = msgs[0].toString;
				} else {
					f = to!(string)(msgs[0]);
				}
				// 第一要素は書式
				data = format(msgs[0], msgs[1..$]);
			} else {
				// なんか
				string[] ss;
				foreach(i, value; msgs) {
					static if(is(T[i] == Text)) {
						ss ~= format("<%s: %s> %s", i, T[i].stringof, value.toString);
					} else {
						ss ~= format("<%s: %s> %s", i, T[i].stringof, value);
					}
				}
				data = to!(string)(ss);
			}
		}

		auto s=format(
			"<%s> %s(%s)%s%s%s",
			date,
			file,
			line,
			repeat("=", 20),
			newline,
			data
		);
		fs.writeLine(s ~ newline);
		fs.flush;
	}
}

debug(log) unittest {
	Logger.flag = true;
	Logger.write("aaa");
	Logger.write(__DATE__);
	Logger.flag = false;
}